#!/usr/bin/env python
# Ce script prend un fichier de R1 et un fichier de R2. Puis, 2 possibilites:
# - enlever les R1 qui n'ont pas de R2 et inversement
# - enlever les R1 qui n'ont pas de R2 et inversement, puis concatener les reads en une seule sequence

#R1R2.py --inR1 fichier1 --inR2 fichier2 --outR1 fichier3 --outR2 fichier4
#R1R2.py --inR1 fichier1 --inR2 fichier2 --outR3 fichier3 --concatenation

import argparse

# Creer le parseur + decrire ce que fait le programme
parser = argparse.ArgumentParser(description="concatener les R1-R2 dans un seul fichier ou les laisser separes dans 2 fichiers")
parser.add_argument( '--concatenation', action='store_true', default=False, help="est-ce qu'il faut concatener les R1-R2 dans un seul fichier ou les laisser separes dans 2 fichiers")
parser.add_argument('--inR1',required=True,help='Fichier avec les R1')
parser.add_argument('--inR2',required=True,help='Fichier avec les R2')
parser.add_argument('--outR1',help='Fichier ou ecrire les R1')
parser.add_argument('--outR2',help='Fichier ou ecrire les R2')
parser.add_argument('--outR3',help='Fichier ou ecrire les R1 et R2 concatenes')

# Recuperer les parametres passes au programme
args = parser.parse_args()

sequences_R1 = dict()
sequences_R2 = dict()
qualite_R1 = dict()
qualite_R2 = dict()

with open(args.inR1,'r') as in_R1:

	en_teteR1 = in_R1.readline().strip()

	while(en_teteR1 != ''):

		sequences_R1[en_teteR1] = in_R1.readline().strip()
		in_R1.readline()
		qualite_R1[en_teteR1] = in_R1.readline().strip()

		sequences_R2[en_teteR1] = None
		qualite_R2[en_teteR1] = None

		en_teteR1 = in_R1.readline().strip()

with open(args.inR2,'r') as in_R2:

        en_teteR2 = in_R2.readline().strip().replace("2:N","1:N") #c'est un truc qui vient apres l'identifiant et change selon que c'est R1 ou R2

        while(en_teteR2 != ''):

                sequences_R2[en_teteR2] = in_R2.readline().strip()
                in_R2.readline()
                qualite_R2[en_teteR2] = in_R2.readline().strip()

		en_teteR2 = in_R2.readline().strip().replace("2:N","1:N")

if args.concatenation:

	with open(args.outR3, 'w') as out_R3:

		for identifiant,sequence in sequences_R1.iteritems():

			if sequences_R2[identifiant] != None :

				out_R3.write(identifiant+'\n')
				out_R3.write(sequence+sequences_R2[identifiant]+'\n')
				out_R3.write('+\n')
				out_R3.write(qualite_R1[identifiant]+qualite_R2[identifiant]+'\n')

else:
        print "Writing files {} and {}".format(args.outR1,args.outR2)
	with open(args.outR1, 'w') as out_R1, open (args.outR2, 'w') as out_R2:

		for identifiant,sequence in sequences_R1.iteritems():

			if sequences_R2[identifiant] != None :

	                        out_R1.write(identifiant+'\n')
        	                out_R1.write(sequence+'\n')
                	        out_R1.write('+\n')
                        	out_R1.write(qualite_R1[identifiant]+'\n')

	                        out_R2.write(identifiant+'\n')
        	                out_R2.write(sequences_R2[identifiant]+'\n')
                	        out_R2.write('+\n')
                        	out_R2.write(qualite_R2[identifiant]+'\n')
